/* ------------------------------------------------------------------------
System       : Manx Aztec C65 Version 3.2b
               MS-DOS cross-development environment
Platform     : Apple IIe 128K PRODOS 8
Program      : dloshow(C) Copyright Bill Buckels 2013.
               All rights reserved.

Description  : Apple //e ProDOS 8 DLOGR Slideshow Program

DLOGR formats supported:  DLO raster or DL1 DL2 bsaved pairs.

Written by   : Bill Buckels
Date Written : January 2013
Revision     : 1.0 First Release
Licence      : You may use this program for whatever you wish as long
               as you agree that Bill Buckels has no warranty or
               liability obligations whatsoever from said use.
------------------------------------------------------------------------ */

#include <g3.h>
#include <stdio.h>
#include <prodir.h>


#include "piclist.inc"


main()
{
   FILE *fp;
   int idx, status,started = 0;
   char picname[66];

   mode80();
   scr_clear();
   scr_curs (0,0);

   dloreson();
   clear2();
   clear1();

 STARTER:;

   status = -1;
   if((fp=fopen("PICLIST","r"))==NULL) {
		/* first time through try to create piclist if it does not exist */
		if (started == 0) {
	       fp = makepiclist();
		}

		if (fp == NULL) goto ENDER;
   }
   started = 1;
   status = 0;

   fgets(picname,66,fp); /* get the first filename */

   while(picname[0]>' ' && picname[0] < '{')
   {
		idx=0;  /* replace carriage return with null */

		while(picname[idx]!=0)
		{

		if(picname[idx]< ' ')picname[idx]= 0;
		else idx++;

		}
		/* load picture - ignore errors */
		dlodelo(picname);
		poke(36,0); poke(37,0); /* HOME MESSY TEXT CURSOR */

		while (kbhit())clearkey();
        /* advance on timeout or advance on keypress */
	   	if (wait(10,XTIME,YTIME)==27)
			{
			 fclose(fp);
			 goto ENDER;
			}
		fgets(picname,66,fp);
	}
	fclose(fp);
	goto STARTER;

  ENDER:;
  clear2();
  clear1();
  dloresoff();
  scr_clear();
  scr_curs (0,0);

  if (status != 0) {
		bellerr();
		puts("! Can't open PICLIST!");
		printf("Press Any Key...");
		getch();
		scr_clear();
		scr_curs (0,0);
  }
  _exit();
}

